/*{ Template_FreeRTOS::.h ************************************************
 
  Example code for FreeRTOS + LCD display on Olimex prototype board STM32-LCD.
  written by Gregor Rebel 2011
 
}*/
#ifndef EXTENSION_100_board_olimex_lcd
#error EXTENSION_100_board_olimex_lcd must be defined!
#endif

//{ Includes *************************************************************

// Basic set of helper functions
#include "stm32_io.h"
#include <stdlib.h>

#define USE_STDPERIPH_DRIVER
#include "stm32f10x.h"
#include "stm32f10x_rcc.h"
#include "stm32f10x_conf.h"
#include "core_cm3.h"        // StdPeripheralsLibrary/CMSIS/CM3/CoreSupport/
#include "bits.h"
#include <string.h>
#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"

//? #include "stm32f10x_systick.h"
#include "lcd-320x240.h"
//#include "touchscreen.h"

//} Includes
//{ Defines/ TypeDefs ****************************************************

typedef struct {
    u16_t BoxColor;
    s16_t PosX;
    s16_t PosY;
    u8_t  Width;
    u8_t  Height;
    s8_t  SpeedX;
    s8_t  SpeedY;
} box2d_t;

typedef struct {
    xQueueHandle DrawQueue;
    box2d_t      Box2Draw;
} drawTaskArgs_t;


//} Defines
//{ Structures/ Enums ****************************************************


//} Structures/ Enums
//{ Structures/ Enums ****************************************************

//} Structures/ Enums
//{ Global Variables *****************************************************



//} Global Variables
//{ Function prototypes **************************************************

// basic hardware intialization
void lcd_boxes_initPorts();

// main entry: initializes hardware + spawns all threads
// returns immediately
void lcd_start_boxes();

// spawns a new box with given parameters
// return: != NULL: settings struct of moving box
box2d_t* newBox(xQueueHandle DrawingQueue, u16_t Color, s16_t X, s16_t Y, u8_t Width, u8_t Height, s8_t SpeedX, s8_t SpeedY);

void tMoveBox(void *pvParameters);
void queueInsert (xQueueHandle DrawQueue, box2d_t *paramms);
void tDrawRect (void *pvParameters);

// main task controlling LCD-panel
//} Function prototypes
